<?php

class GalleryPage extends Page {
	

	public static $db = array(
	'AlbumDescription'=>'Text'						  
	);
	
	// Used to automatically include photos in a specific folder
	static $has_one = array(
		"AutoFolder" => "Folder"
	);
	
	// One gallery page has many gallery images
	public static $has_many = array(
    	'GalleryImages' => 'GalleryImage'
  	);

   public function getCMSFields() {
	   
   		$fields = parent::getCMSFields();
		
			$gridFieldConfig = GridFieldConfig_RecordEditor::create(); 
			$gridFieldConfig->addComponent(new GridFieldBulkEditingTools());
			$gridFieldConfig->addComponent(new GridFieldSortableRows('SortOrder'));    

			$fields->addFieldToTab('Root.GalleryImages',new TextAreaField('AlbumDescription'));	
			// Creates drop down menu so that you can select the folder that you want included
			$fields->addFieldToTab("Root.GalleryImages", new TreeDropdownField(
			"AutoFolderID",
			"Include existing images from file store - Select folder from drop down and save ",
			"Folder"		
			));
			// Creates sortable grid field
			$gridfield = new GridField("GalleryImages", "Gallery Images", $this->GalleryImages()->sort("SortOrder"), $gridFieldConfig);
			$fields->addFieldToTab('Root.GalleryImages', $gridfield);
						
		return $fields;
		
  }

public function onBeforeWrite() {
		parent::onBeforeWrite();
		$imageAdded = false;
		// Checks if a folder has been selected
		if($this->AutoFolderID) {
			// If folder is seleced script filters the images/folders in the file store with the AutoFolder we chose from the dropdown
			if($folder = DataObject::get_by_id("Folder", $this->AutoFolderID)) {
				// If the images parent id (i.e his folder) matches our folder above then run loop on each image 
				if($files = DataObject::get("Image", "ParentID = ".$folder->ID)) {
					foreach($files as $file) {
						if(DataObject::get_one("GalleryImage", "ImageID = ".$file->ID." AND GalleryPageID = ".$this->ID)) {
							//If the image already exisits in our gallery then do nothing
						}
						else {
							// Add the image to our gallery
							$GalleryImage = new GalleryImage();
							$GalleryImage->Title = $file->Title;
							$GalleryImage->ImageID = $file->ID;
							$GalleryImage->GalleryPageID = $this->ID;
							$GalleryImage->write();
							$GalleryImage = true;
						}
					}
				}
			}
		}
		// Check if the image is in our image gallert
		if($GalleryImages = DataObject::get("GalleryImage", "GalleryPageID = ".$this->ID)){
			foreach($GalleryImages as $GalleryImage) {
				// For each image in our gallery, change the Title of the image to the file name. Eg if file name is 'fish.jpg' make image Title 'fish'
				if($image = DataObject::get_one("Image", "File.ID = ".$GalleryImage->ImageID." AND File.Title <> '".$GalleryImage->Title."'")) {
					$image->Title = $image->Name = $GalleryImage->Title;
					$image->write();
				}
			}
		}
	
	}

}


class GalleryPage_Controller extends Page_Controller {
	
	public static $allowed_actions = array (
	);
	
	public function GetGalleryImages() {
		return $this->GalleryImages()->sort("SortOrder");
	}
	

	public function init() {
		parent::init();		
		Requirements::css('ss3Gallery/css/prettyPhoto.css');
		// I recommend you comment prettyPhotoCustom out and put this file in your themes folder to customise look and feel
		// Dont forget to include it in your page.ss file in your themes folder
		Requirements::css('ss3Gallery/css/prettyPhotoCustom.css'); 
		Requirements::javascript('ss3Gallery/js/jquery-1.7.1.min.js');
		Requirements::javascript('ss3Gallery/js/jquery.prettyPhoto.js');	
		Requirements::customScript('						   
		$(document).ready(function(){
		$("a[rel^=\'prettyPhoto\']").prettyPhoto();
		});
		');
	}

}